"{ Package: 'jn:refactoring_custom' }"

CustomCodeGenerator subclass:#CustomTestCaseCodeGenerator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:''
!

!CustomTestCaseCodeGenerator class methodsFor:'accessing-presentation'!

description
    ^ 'Generates TestCase subclass for selected classes'

    "Modified: / 27-04-2014 / 11:03:05 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

label
    ^ 'TestCase class'

    "Modified: / 27-04-2014 / 10:46:01 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomTestCaseCodeGenerator class methodsFor:'queries'!

availableInContext:aCustomContext 
    ^aCustomContext selectedClasses notEmptyOrNil
!

availableInPerspective:aCustomPerspective 
    ^aCustomPerspective isClassPerspective
! !

!CustomTestCaseCodeGenerator methodsFor:'executing'!

buildInContext:aCustomContext 

    aCustomContext selectedClasses do: [ :class |
        | className testClassName |

        className := class nameWithoutPrefix.

        (className endsWith: 'Tests') ifFalse: [
            | testClass |

            testClassName := className, 'Tests'.

            testClass := builder createClass.
            testClass
                className: testClassName;
                superclassName: 'TestCase'.

            (builder createMethod)
                class: testClass;
                protocol: 'tests';
                source: ('test_something
                    self assert: ''a'' = ''b''').

            (builder createMethod)
                class: testClass;
                protocol: 'initialization & release';
                source: ('setUp
                    ^ self').

            (builder createMethod)
                class: testClass;
                protocol: 'initialization & release';
                source: ('tearDown
                    ^ self').
        ]
    ].

    "Modified: / 27-04-2014 / 17:16:12 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

