"{ Package: 'jn:refactoring_custom' }"

TestCase subclass:#CustomVisitorCodeGeneratorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!

!CustomVisitorCodeGeneratorTests methodsFor:'tests'!

test_dummy

    self assert: 'ab' = 'ab'.

    "Created: / 25-08-2013 / 09:46:14 / user"
    "Modified: / 16-03-2014 / 19:07:08 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_visitor_pattern_methods_generated
    "check if methods for visitor pattern are correctly generated"
    
    | context codeGenerator aClass |

    "/ Not really a test, one should test whether all methods
    "/ exists and what their source is...
    codeGenerator := CustomVisitorCodeGenerator new.
    aClass := CustomDummyTests.
    context := CustomSubContext new.
    context addSelectedClass: aClass.
    self assert:((aClass includesSelector:#visit:) not).
    codeGenerator executeInContext:context.
    self assert:(aClass includesSelector:#visit:).
    self assert: (aClass sourceCodeAt: #visit:) = ('visit:anObject 
    "visit anObject (visitor pattern).
     The object should call back one of my visitXXXX methods."

    ^ anObject acceptVisitor:self
') .
    aClass removeSelector:#visit:.
    self assert:((aClass includesSelector:#visit:) not).

    "Created: / 25-08-2013 / 09:44:35 / user"
    "Modified: / 03-09-2013 / 21:52:14 / user"
    "Modified (format): / 01-12-2013 / 00:28:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 26-04-2014 / 00:24:19 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

