"{ Package: 'jn:refactoring_custom' }"

LibraryDefinition subclass:#jn_refactoring_custom
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!jn_refactoring_custom class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list all required mandatory packages.
     Packages are mandatory, if they contain superclasses of the package's classes
     or classes which are extended by this package.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies
     (the browser has a menu function for that)"

    ^ #(
        #'stx:goodies/refactoryBrowser/parser'    "RBProgramNodeVisitor - superclass of CustomSourceCodeBuilder "
        #'stx:goodies/sunit'    "TestAsserter - superclass of CustomAccessMethodsCodeGeneratorTests "
        #'stx:libbasic'    "LibraryDefinition - superclass of jn_refactoring_custom "
        #'stx:libtool'    "CodeGenerator - superclass of CustomSourceCodeBuilder "
        #'stx:libview2'    "ApplicationModel - extended "
    )
!

referencedPreRequisites
    "list all packages containing classes referenced by the packages's members.
     This list can be maintained manually or (better) generated and
     updated by looking for global variable accesses
     (the browser has a menu function for that)
     However, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPreRequisites method."

    ^ #(
        #'stx:goodies/refactoryBrowser/changes'    "CompositeRefactoryChange - referenced by CustomSourceCodeBuilder::Method>>createChange "
        #'stx:goodies/refactoryBrowser/helpers'    "RBClass - referenced by CustomCodeGeneratorOrRefactoring>>compile:forClass:inCategory:skipIfSame: "
        #'stx:libview'    "WindowGroup - referenced by CustomCodeGenerator>>executeInContext: "
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!jn_refactoring_custom class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (CustomAccessMethodsCodeGeneratorTests autoload)
        (CustomCodeGeneratorClassGeneratorTests autoload)
        CustomCodeGeneratorOrRefactoring
        CustomContext
        CustomDialog
        (CustomDummyTests autoload)
        CustomManager
        CustomMenuBuilder
        CustomPerspective
        CustomSourceCodeBuilder
        (CustomSourceCodeBuilderTests autoload)
        (CustomSubclassResponsibilityCodeGeneratorTests autoload)
        (CustomVisitorCodeGeneratorAcceptVisitorTests autoload)
        (CustomVisitorCodeGeneratorTests autoload)
        TestClass
        #'jn_refactoring_custom'
        CustomBrowserContext
        CustomCodeGenerator
        CustomDialogMock
        CustomRefactoring
        CustomSubContext
        CustomAccessMethodsCodeGenerator
        CustomCodeGeneratorClassGenerator
        CustomFooBarBazCodeGenerator
        CustomGetterMethodsCodeGenerator
        CustomIsAbstractCodeGenerator
        CustomSubclassResponsibilityCodeGenerator
        CustomTestCaseCodeGenerator
        CustomVisitorCodeGenerator
        CustomVisitorCodeGeneratorAcceptVisitor
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        #'Tools::NewSystemBrowser' classMenuExtensionCustomRefactorings:
    )
! !

!jn_refactoring_custom class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'My Company'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'My CopyRight or CopyLeft'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'ProductName'
! !

!jn_refactoring_custom class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

